#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include <stdlib.h>

#include "pcd8544.h"
#include "main.h"

// Buttons initialization.
void initButtons()
{
	DDRD  &= ~(1 << PD0);
	PORTD |= 1 << PD0;
	DDRD  &= ~(1 << PD1);
	PORTD |= 1 << PD1;
	DDRD  &= ~(1 << PD2);
	PORTD |= 1 << PD2;
	DDRD  &= ~(1 << PD3);
	PORTD |= 1 << PD3;
}

int main()
{
    initButtons();
	LcdInit();
    
    int choice = 0, flicker = 0;
    
    byte button = -1;
    
    while(button != 0 && button != 2)
    {   
        LcdClear();
        
        if(choice == 0)
        {
            LcdGotoXYFont(4,5);
            LcdStr(FONT_1X, "TETRIS");
            
            if(flicker == 1)
            {
                LcdGotoXYFont(4,2);
                LcdStr(FONT_1X, "SNAKE");
            }
        }
        else
        {
            LcdGotoXYFont(4,2);
            LcdStr(FONT_1X, "SNAKE");
            
            if(flicker == 1)
            {
                LcdGotoXYFont(4,5);
                LcdStr(FONT_1X, "TETRIS");
            }
        }
        
        LcdUpdate();
        _delay_ms(100);
        
        flicker = 1 - flicker;
        
        checkButton(&button);
        if(button == 3) choice = 0;
        if(button == 1) choice = 1;
    }
    
    if(choice == 0) snake_main();
    if(choice == 1) tetris_main();
}