#ifndef TETRIS_H
#define TETRIS_H

#define TABLE_SIZE_X 10
#define TABLE_SIZE_Y 25

#define FULL_LINE 0x03FF

#define SPEED_INC 25

typedef char sbyte;

typedef enum
{
    L_1, L_2, L_3, L_4,
    J_1, J_2, J_3, J_4,
    T_1, T_2, T_3, T_4,
	I_1, I_2,
    S_1, S_2,
    Z_1, Z_2,    
	O,
    NUM_TYPES
}piece_type;

typedef enum
{
    LEFT,
    RIGHT,
    ROTATE,
    DOWN
}button_t;

typedef struct piece
{
    sbyte x, y;
    sbyte left_clearance, right_clearance;
    piece_type type;
    int segment_offset_x[3];
    int segment_offset_y[3];
}piece_t;

void tetris_main();
void draw_border();
void draw_square3x3(sbyte, sbyte);
void draw_piece();
void init_table();
void draw_table();
void set_piece_offsets();

sbyte check_position(piece_t *);
sbyte can_advance(piece_t *);
void try_move(piece_t *, sbyte);
void try_rotate(piece_t *, piece_type);
void rotate(piece_t *);
void copy_to_table(piece_t *);

#endif